Index: LMDZ5/branches/testing/libf/phylmd/hgardfou.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/hgardfou.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/hgardfou.F	(revision 1795)
@@ -2,6 +2,7 @@
 ! $Id$
       SUBROUTINE hgardfou (t,tsol,text)
-      use dimphy
-      use phys_state_var_mod
+      USE dimphy
+      USE phys_state_var_mod
+      USE indice_sol_mod
       IMPLICIT none
 c======================================================================
@@ -10,5 +11,4 @@
 #include "dimensions.h"
 #include "YOMCST.h"
-#include "indicesol.h"
 #include "iniprint.h"
       REAL t(klon,klev), tsol(klon,nbsrf)
@@ -57,5 +57,5 @@
            DO i = 1, jbad
              WRITE(lunout,*)
-     $       'i,k,temperature,lon,lat,pourc ter,oce,lic,sic =',
+     $       'i,k,temperature,lon,lat,pourc ter,lic,oce,sic =',
      $       jadrs(i),k,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i)),
      $       (pctsrf(jadrs(i),nsrf),nsrf=1,nbsrf)
@@ -78,5 +78,5 @@
            DO i = 1, jbad
              WRITE(lunout,*)
-     $       'i,k,temperature,lon,lat,pourc ter,oce,lic,sic =',
+     $       'i,k,temperature,lon,lat,pourc ter,lic,oce,sic =',
      $       jadrs(i),k,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i)),
      $       (pctsrf(jadrs(i),nsrf),nsrf=1,nbsrf)
@@ -104,5 +104,5 @@
            DO i = 1, jbad
             WRITE(lunout,*) 
-     $      'i,nsrf,temperature,lon,lat,pourc ter,oce,lic,sic ='
+     $      'i,nsrf,temperature,lon,lat,pourc ter,lic,oce,sic ='
      $      ,jadrs(i),nsrf,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i))
      $      ,pctsrf(jadrs(i),nsrf)
@@ -125,5 +125,5 @@
            DO i = 1, jbad
             WRITE(lunout,*) 
-     $      'i,nsrf,temperature,lon,lat,pourc ter,oce,lic,sic ='
+     $      'i,nsrf,temperature,lon,lat,pourc ter,lic,oce,sic ='
      $      ,jadrs(i),nsrf,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i))
      $      ,pctsrf(jadrs(i),nsrf)
Index: LMDZ5/branches/testing/libf/phylmd/hydrol.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/hydrol.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/hydrol.F	(revision 1795)
@@ -7,4 +7,6 @@
      .                  agesno, tsol,qsol,snow,runoff)
       USE dimphy
+      USE indice_sol_mod
+
       IMPLICIT none
 c======================================================================
@@ -26,5 +28,4 @@
 cym#include "dimphy.h"
 #include "YOMCST.h"
-#include "indicesol.h"
 c
       REAL chasno ! epaisseur du sol: 0.15 m
Index: LMDZ5/branches/testing/libf/phylmd/indice_sol_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/indice_sol_mod.F90	(revision 1795)
+++ LMDZ5/branches/testing/libf/phylmd/indice_sol_mod.F90	(revision 1795)
@@ -0,0 +1,12 @@
+      MODULE indice_sol_mod
+            INTEGER, PARAMETER :: nbsrf = 4 ! nombre de sous-fractions pour une maille
+            INTEGER, PARAMETER :: is_ter=1, is_lic=2, is_oce = 3, is_sic=4
+                              ! terre ! ocean ! glacier continental ! glace de mer
+
+            INTEGER, PARAMETER :: is_ave=nbsrf+1 ! glacier continental
+            REAL, PARAMETER :: epsfra=1.0E-05
+
+            CHARACTER(len=3), DIMENSION(nbsrf), PARAMETER :: clnsurf = (/'ter', 'lic', 'oce', 'sic'/)
+
+      END MODULE indice_sol_mod
+
Index: LMDZ5/branches/testing/libf/phylmd/init_be.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/init_be.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/init_be.F90	(revision 1795)
@@ -7,4 +7,5 @@
   USE comgeomphy
   USE infotrac, ONLY : nbtr
+  USE indice_sol_mod
     
   IMPLICIT NONE 
@@ -21,5 +22,4 @@
   INCLUDE "YOMCST.h"
   INCLUDE "YOECUMF.h" 
-  INCLUDE "indicesol.h"
 
 !
@@ -47,5 +47,5 @@
   INTEGER              :: nref
   PARAMETER (nref=39)
-  REAL,DIMENSION(nref) :: pref      ! grille de pression de reference (bas des couches)
+  REAL,DIMENSION(nref), SAVE :: pref      ! grille de pression de reference (bas des couches)
   DATA pref  /   &
       101249.99999999994, 100387.17261011522, 99447.35334189111,  98357.43412194174,   &
Index: LMDZ5/branches/testing/libf/phylmd/initphysto.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/initphysto.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/initphysto.F90	(revision 1795)
@@ -9,4 +9,5 @@
   USE iophy
   USE control_mod
+  USE indice_sol_mod
   
   IMPLICIT NONE
@@ -46,5 +47,4 @@
   INCLUDE "description.h"
   INCLUDE "serre.h"
-  INCLUDE "indicesol.h"
 
 !   Arguments
Index: LMDZ5/branches/testing/libf/phylmd/initrrnpb.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/initrrnpb.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/initrrnpb.F90	(revision 1795)
@@ -6,4 +6,5 @@
   USE infotrac, ONLY : nbtr
   USE traclmdz_mod, ONLY : id_rn, id_pb
+  USE indice_sol_mod
   IMPLICIT NONE
 !======================================================================
@@ -24,7 +25,5 @@
 ! scavtr...output-R- Coefficient de lessivage
 !======================================================================
-  INCLUDE "indicesol.h"
-!======================================================================
-
+ 
   REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: pctsrf
   REAL,DIMENSION(klon,nbsrf),INTENT(IN) :: ftsol
Index: LMDZ5/branches/testing/libf/phylmd/interfoce_lim.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/interfoce_lim.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/interfoce_lim.F90	(revision 1795)
@@ -9,8 +9,8 @@
   USE mod_grid_phy_lmdz
   USE mod_phys_lmdz_para
+  USE indice_sol_mod
   
   IMPLICIT NONE
   
-  INCLUDE "indicesol.h"
   INCLUDE "netcdf.inc"
 
Index: LMDZ5/branches/testing/libf/phylmd/iophy.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 1795)
@@ -6,12 +6,15 @@
 ! abd  REAL,private,allocatable,dimension(:),save :: io_lat
 ! abd  REAL,private,allocatable,dimension(:),save :: io_lon
-  REAL,allocatable,dimension(:),save :: io_lat
-  REAL,allocatable,dimension(:),save :: io_lon
-  INTEGER, save :: phys_domain_id
-  INTEGER, save :: npstn
-  INTEGER, allocatable, dimension(:), save :: nptabij
+  REAL,ALLOCATABLE,DIMENSION(:),SAVE :: io_lat
+  REAL,ALLOCATABLE,DIMENSION(:),SAVE :: io_lon
+  INTEGER, SAVE :: phys_domain_id
+  INTEGER, SAVE :: npstn
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE :: nptabij
+  INTEGER, SAVE :: itau_iophy
+
+!$OMP THREADPRIVATE(itau_iophy)
   
   INTERFACE histwrite_phy
-    MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy
+    MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy,histwrite2d_phy_old,histwrite3d_phy_old
   END INTERFACE
 
@@ -322,10 +325,12 @@
   end subroutine histbeg_phy_points
  
-  subroutine histwrite2d_phy(nid,lpoint,name,itau,field)
-  USE dimphy
-  USE mod_phys_lmdz_para
+  SUBROUTINE histwrite2d_phy_old(nid,lpoint,name,itau,field)
+  USE dimphy
+  USE mod_phys_lmdz_para
+  USE phys_output_var_mod
   USE ioipsl
-  implicit none
+  IMPLICIT NONE
   include 'dimensions.h'
+  include 'iniprint.h'
     
     integer,intent(in) :: nid
@@ -341,4 +346,5 @@
     real,allocatable,dimension(:) :: fieldok
 
+
     IF (size(field)/=klon) CALL abort_gcm('iophy::histwrite2d','Field first dimension not equal to klon',1)
     
@@ -349,5 +355,7 @@
      ALLOCATE(index2d(iim*jj_nb))
      ALLOCATE(fieldok(iim*jj_nb))
+     IF (prt_level >= 9) write(lunout,*)'Sending ',name,' to IOIPSL'
      CALL histwrite(nid,name,itau,Field2d,iim*jj_nb,index2d)
+     IF (prt_level >= 9) write(lunout,*)'Finished sending ',name,' to IOIPSL'
     else
      ALLOCATE(fieldok(npstn))
@@ -369,19 +377,25 @@
       ENDDO
      endif
+     IF (prt_level >= 9) write(lunout,*)'Sending ',name,' to IOIPSL'
      CALL histwrite(nid,name,itau,fieldok,npstn,index2d)
+     IF (prt_level >= 9) write(lunout,*)'Finished sending ',name,' to IOIPSL'
 !
     endif
     deallocate(index2d)
     deallocate(fieldok)
-!$OMP END MASTER    
-  end subroutine histwrite2d_phy
-
-  subroutine histwrite3d_phy(nid,lpoint,name,itau,field)
-  USE dimphy
-  USE mod_phys_lmdz_para
+!$OMP END MASTER   
+
+ 
+  end subroutine histwrite2d_phy_old
+
+  subroutine histwrite3d_phy_old(nid,lpoint,name,itau,field)
+  USE dimphy
+  USE mod_phys_lmdz_para
+  USE phys_output_var_mod
 
   use ioipsl
   implicit none
   include 'dimensions.h'
+  include 'iniprint.h'
     
     integer,intent(in) :: nid
@@ -396,4 +410,5 @@
     real,allocatable, dimension(:,:) :: fieldok
 
+
     IF (size(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first dimension not equal to klon',1)
     nlev=size(field,2)
@@ -411,6 +426,8 @@
      ALLOCATE(index3d(iim*jj_nb*nlev))
      ALLOCATE(fieldok(iim*jj_nb,nlev))
+     IF (prt_level >= 9) write(lunout,*)'Sending ',name,' to IOIPSL'
      CALL histwrite(nid,name,itau,Field3d,iim*jj_nb*nlev,index3d)
-    else
+     IF (prt_level >= 9) write(lunout,*)'Finished sending ',name,' to IOIPSL'
+   else
       nlev=size(field,2)
       ALLOCATE(index3d(npstn*nlev))
@@ -435,10 +452,204 @@
        ENDDO
       endif
+      IF (prt_level >= 9) write(lunout,*)'Sending ',name,' to IOIPSL'
       CALL histwrite(nid,name,itau,fieldok,npstn*nlev,index3d)
+      IF (prt_level >= 9) write(lunout,*)'Finished sending ',name,' to IOIPSL'
     endif 
   deallocate(index3d)
   deallocate(fieldok)
 !$OMP END MASTER    
-  end subroutine histwrite3d_phy
+
+  end subroutine histwrite3d_phy_old
+
+
+! ug NOUVELLE VERSION DES WRITE AVEC LA BOUCLE DO RENTREE
+  SUBROUTINE histwrite2d_phy(var,field, STD_iff)
+  USE dimphy
+  USE mod_phys_lmdz_para
+  USE ioipsl
+!Pour avoir nfiles, nidfiles tout ça tout ça...
+  USE phys_output_var_mod
+  
+  
+
+#ifdef CPP_XIOS
+!  USE WXIOS
+#endif
+
+  IMPLICIT NONE
+  include 'dimensions.h'
+    
+!    integer,intent(in) :: nid
+!    logical,intent(in) :: lpoint 
+!    character*(*), intent(IN) :: name
+!    integer, intent(in) :: itau
+!    real,dimension(:),intent(in) :: field
+
+      TYPE(ctrl_out), INTENT(IN) :: var
+      REAL, DIMENSION(:), INTENT(IN) :: field
+      INTEGER, INTENT(IN), OPTIONAL :: STD_iff ! ug RUSTINE POUR LES STD LEVS.....
+      
+      INTEGER :: iff, iff_beg, iff_end
+      
+    REAL,dimension(klon_mpi) :: buffer_omp
+    INTEGER, allocatable, dimension(:) :: index2d
+    REAL :: Field2d(iim,jj_nb)
+
+    INTEGER :: ip
+    REAL, ALLOCATABLE, DIMENSION(:) :: fieldok
+
+! ug RUSTINE POUR LES STD LEVS.....
+      IF (PRESENT(STD_iff)) THEN
+            iff_beg = STD_iff
+            iff_end = STD_iff
+      ELSE
+            iff_beg = 1
+            iff_end = nfiles
+      END IF
+
+    IF (size(field)/=klon) CALL abort_gcm('iophy::histwrite2d','Field first dimension not equal to klon',1)
+    
+    CALL Gather_omp(field,buffer_omp)    
+!$OMP MASTER
+    CALL grid1Dto2D_mpi(buffer_omp,Field2d)
+    
+! La boucle sur les fichiers:
+      DO iff=iff_beg, iff_end
+            IF (var%flag(iff) <= lev_files(iff) .AND. clef_files(iff)) THEN 
+    
+                  IF(.NOT.clef_stations(iff)) THEN
+                        ALLOCATE(index2d(iim*jj_nb))
+                        ALLOCATE(fieldok(iim*jj_nb))
+     
+                        CALL histwrite(nid_files(iff),var%name,itau_iophy,Field2d,iim*jj_nb,index2d)
+#ifdef CPP_XIOS
+!                        IF (iff .EQ. 1) THEN
+!                              CALL wxios_write_2D(var%name, Field2d)
+!                        ENDIF
+#endif
+                  ELSE 
+                        ALLOCATE(fieldok(npstn))
+                        ALLOCATE(index2d(npstn))
+
+                        IF (is_sequential) THEN
+!                            klon_mpi_begin=1
+!                             klon_mpi_end=klon
+                              DO ip=1, npstn
+                                    fieldok(ip)=buffer_omp(nptabij(ip))
+                              ENDDO
+                             ELSE
+                              DO ip=1, npstn
+!                                   print*,'histwrite2d is_sequential npstn ip name nptabij',npstn,ip,name,nptabij(ip)
+                                     IF(nptabij(ip).GE.klon_mpi_begin.AND. &
+                                        nptabij(ip).LE.klon_mpi_end) THEN
+                                       fieldok(ip)=buffer_omp(nptabij(ip)-klon_mpi_begin+1)
+                                     ENDIF
+                              ENDDO
+                       ENDIF
+     
+                       CALL histwrite(nid_files(iff),var%name,itau_iophy,fieldok,npstn,index2d)
+                  ENDIF
+                  
+                deallocate(index2d)
+                deallocate(fieldok)
+            ENDIF !levfiles
+      ENDDO
+!$OMP END MASTER   
+
+  END SUBROUTINE histwrite2d_phy
+
+
+! ug NOUVELLE VERSION DES WRITE AVEC LA BOUCLE DO RENTREE
+  SUBROUTINE histwrite3d_phy(var, field)
+  USE dimphy
+  USE mod_phys_lmdz_para
+
+  use ioipsl
+!Pour avoir nfiles, nidfiles tout ça tout ça...
+  USE phys_output_var_mod  
+  
+
+#ifdef CPP_XIOS
+! USE WXIOS
+#endif
+
+
+  IMPLICIT NONE
+  include 'dimensions.h'
+    
+!    integer,intent(in) :: nid
+!    logical,intent(in) :: lpoint
+!    character*(*), intent(IN) :: name
+!    integer, intent(in) :: itau
+!    real,dimension(:,:),intent(in) :: field  ! --> field(klon,:)
+
+      TYPE(ctrl_out), INTENT(IN) :: var
+      REAL, DIMENSION(:,:), INTENT(IN) :: field ! --> field(klon,:)
+
+
+    REAL,DIMENSION(klon_mpi,SIZE(field,2)) :: buffer_omp
+    REAL :: Field3d(iim,jj_nb,SIZE(field,2))
+    INTEGER :: ip, n, nlev, iff
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: index3d
+    REAL,ALLOCATABLE, DIMENSION(:,:) :: fieldok
+
+    IF (size(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first dimension not equal to klon',1)
+    nlev=size(field,2)
+
+!   print*,'hist3d_phy mpi_rank npstn=',mpi_rank,npstn
+
+!   DO ip=1, npstn
+!    print*,'hist3d_phy mpi_rank nptabij',mpi_rank,nptabij(ip)
+!   ENDDO
+
+    CALL Gather_omp(field,buffer_omp)
+!$OMP MASTER
+    CALL grid1Dto2D_mpi(buffer_omp,field3d)
+
+
+! BOUCLE SUR LES FICHIERS
+      DO iff=1, nfiles
+            IF (var%flag(iff) <= lev_files(iff) .AND. clef_files(iff)) THEN
+                IF (.NOT.clef_stations(iff)) THEN
+                        ALLOCATE(index3d(iim*jj_nb*nlev))
+                        ALLOCATE(fieldok(iim*jj_nb,nlev))
+                        CALL histwrite(nid_files(iff),var%name,itau_iophy,Field3d,iim*jj_nb*nlev,index3d)
+#ifdef CPP_XIOS
+!                        IF (iff .EQ. 1) THEN
+!                              CALL wxios_write_3D(var%name, Field3d(:,:,1:klev))
+!                        ENDIF
+#endif
+                        
+                ELSE 
+                        nlev=size(field,2)
+                        ALLOCATE(index3d(npstn*nlev))
+                        ALLOCATE(fieldok(npstn,nlev))
+
+                        IF (is_sequential) THEN
+            !                  klon_mpi_begin=1
+            !                  klon_mpi_end=klon
+                              DO n=1, nlev
+                                    DO ip=1, npstn
+                                          fieldok(ip,n)=buffer_omp(nptabij(ip),n)
+                                    ENDDO
+                              ENDDO
+                        ELSE
+                              DO n=1, nlev
+                                    DO ip=1, npstn
+                                                IF(nptabij(ip).GE.klon_mpi_begin.AND. &
+                                                      nptabij(ip).LE.klon_mpi_end) THEN
+                                                fieldok(ip,n)=buffer_omp(nptabij(ip)-klon_mpi_begin+1,n)
+                                          ENDIF
+                                    ENDDO
+                              ENDDO
+                        ENDIF
+                        CALL histwrite(nid_files(iff),var%name,itau_iophy,fieldok,npstn*nlev,index3d)
+                  ENDIF 
+                  deallocate(index3d)
+                  deallocate(fieldok)
+            ENDIF
+      ENDDO
+!$OMP END MASTER   
+  END SUBROUTINE histwrite3d_phy
   
 end module iophy
Index: LMDZ5/branches/testing/libf/phylmd/limit_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/limit_netcdf.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/limit_netcdf.F90	(revision 1795)
@@ -21,4 +21,5 @@
 !-------------------------------------------------------------------------------
   USE control_mod
+  USE indice_sol_mod
 #ifdef CPP_EARTH
   USE dimphy
@@ -50,5 +51,4 @@
 #include "comgeom2.h"
 #include "comconst.h"
-#include "indicesol.h"
 
 !--- INPUT NETCDF FILES NAMES --------------------------------------------------
@@ -276,7 +276,8 @@
   USE phys_state_var_mod, ONLY : pctsrf
   USE control_mod
-  use pchsp_95_m, only: pchsp_95
-  use pchfe_95_m, only: pchfe_95
-  use arth_m, only: arth
+  USE pchsp_95_m, only: pchsp_95
+  USE pchfe_95_m, only: pchfe_95
+  USE arth_m, only: arth
+  USE indice_sol_mod
 
   IMPLICIT NONE
@@ -284,5 +285,4 @@
 #include "paramet.h"
 #include "comgeom2.h"
-#include "indicesol.h"
 #include "iniprint.h"
 !-----------------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/phylmd/limit_read_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/limit_read_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/limit_read_mod.F90	(revision 1795)
@@ -38,5 +38,5 @@
 
     USE dimphy
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
 
 ! Input arguments
@@ -146,8 +146,8 @@
     USE surface_data, ONLY : type_ocean, ok_veget
     USE netcdf
+    USE indice_sol_mod
 
     IMPLICIT NONE
     
-    INCLUDE "indicesol.h"
     INCLUDE "iniprint.h"
 
Index: LMDZ5/branches/testing/libf/phylmd/limit_slab.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/limit_slab.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/limit_slab.F90	(revision 1795)
@@ -7,8 +7,8 @@
   USE mod_phys_lmdz_para
   USE netcdf 
+  USE indice_sol_mod
 
   IMPLICIT NONE
 
-  INCLUDE "indicesol.h"
   INCLUDE "temps.h"
   INCLUDE "clesphys.h"
Index: LMDZ5/branches/testing/libf/phylmd/ocean_cpl_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/ocean_cpl_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/ocean_cpl_mod.F90	(revision 1795)
@@ -62,6 +62,6 @@
     USE cpl_mod
     USE calcul_fluxs_mod
-
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "YOMCST.h"
 !    
@@ -197,6 +197,6 @@
     USE cpl_mod
     USE calcul_fluxs_mod
-
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "YOMCST.h"
 
Index: LMDZ5/branches/testing/libf/phylmd/ocean_forced_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/ocean_forced_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/ocean_forced_mod.F90	(revision 1795)
@@ -30,5 +30,6 @@
     USE calcul_fluxs_mod
     USE limit_read_mod
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "YOMCST.h"
 
@@ -137,6 +138,6 @@
     USE limit_read_mod
     USE fonte_neige_mod,  ONLY : fonte_neige
-
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "dimsoil.h"
     INCLUDE "YOMCST.h"
Index: LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90	(revision 1795)
@@ -18,5 +18,6 @@
     USE limit_read_mod
     USE surface_data
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
 !    INCLUDE "clesphys.h"
 
@@ -60,6 +61,6 @@
     USE dimphy
     USE calcul_fluxs_mod
-  
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "iniprint.h"
 
Index: LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 1795)
@@ -42,5 +42,6 @@
   REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: agesno ! age of snow at surface
   !$OMP THREADPRIVATE(agesno)
-  REAL, ALLOCATABLE, DIMENSION(:,:,:), PRIVATE, SAVE :: ftsoil ! soil temperature
+! Correction pour le cas AMMA (PRIVATE)
+  REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE :: ftsoil ! soil temperature
   !$OMP THREADPRIVATE(ftsoil)
 
@@ -56,5 +57,6 @@
 ! for the index of the different surfaces and tests the choice of type of ocean.
 
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "dimsoil.h"
     INCLUDE "iniprint.h"
@@ -176,5 +178,5 @@
        alb1_m,    alb2_m,    zxsens,   zxevap,        &
        zxtsol,    zxfluxlat, zt2m,     qsat2m,        &
-       d_t,       d_q,       d_u,      d_v,           & 
+       d_t,       d_q,       d_u,      d_v, d_t_diss, & 
        zcoefh,    zcoefm,    slab_wfbils,             &
        qsol_d,    zq2m,      s_pblh,   s_plcl,        &
@@ -247,7 +249,8 @@
 !
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
+    USE indice_sol_mod
+
     IMPLICIT NONE
 
-    INCLUDE "indicesol.h"
     INCLUDE "dimsoil.h"
     INCLUDE "YOMCST.h"
@@ -259,4 +262,6 @@
     INCLUDE "YOETHF.h"
     INCLUDE "temps.h"
+!****************************************************************************************
+! Declarations specifiques pour le 1D. A reprendre 
 ! Input variables
 !****************************************************************************************
@@ -291,5 +296,5 @@
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: u10m    ! u speed at 10m
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: v10m    ! v speed at 10m
-    REAL, DIMENSION(klon, klev+1, nbsrf), INTENT(INOUT) :: tke 
+    REAL, DIMENSION(klon, klev+1, nbsrf+1), INTENT(INOUT) :: tke 
 
 ! Output variables
@@ -310,9 +315,10 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: qsat2m
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: d_t        ! change in temperature 
+    REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: d_t_diss       ! change in temperature 
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: d_q        ! change in water vapour
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: d_u        ! change in u speed
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: d_v        ! change in v speed
-    REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zcoefh     ! coef for turbulent diffusion of T and Q, mean for each grid point
-    REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zcoefm     ! coef for turbulent diffusion of U and V (?), mean for each grid point
+    REAL, DIMENSION(klon, klev,nbsrf+1),  INTENT(OUT)       :: zcoefh     ! coef for turbulent diffusion of T and Q, mean for each grid point
+    REAL, DIMENSION(klon, klev,nbsrf+1),  INTENT(OUT)       :: zcoefm     ! coef for turbulent diffusion of U and V (?), mean for each grid point
 
 ! Output only for diagnostics
@@ -424,9 +430,9 @@
     REAL, DIMENSION(klon)              :: ztsol
     REAL, DIMENSION(klon)              :: alb_m  ! mean albedo for whole SW interval
-    REAL, DIMENSION(klon,klev)         :: y_d_t, y_d_q
+    REAL, DIMENSION(klon,klev)         :: y_d_t, y_d_q, y_d_t_diss
     REAL, DIMENSION(klon,klev)         :: y_d_u, y_d_v
     REAL, DIMENSION(klon,klev)         :: y_flux_t, y_flux_q
     REAL, DIMENSION(klon,klev)         :: y_flux_u, y_flux_v
-    REAL, DIMENSION(klon,klev)         :: ycoefh, ycoefm
+    REAL, DIMENSION(klon,klev)         :: ycoefh, ycoefm,ycoefq
     REAL, DIMENSION(klon)              :: ycdragh, ycdragm
     REAL, DIMENSION(klon,klev)         :: yu, yv
@@ -470,8 +476,8 @@
 !****************************************************************************************
 ! Declarations specifiques pour le 1D. A reprendre 
+!****************************************************************************************
   REAL  :: fsens,flat
   LOGICAL :: ok_flux_surf ! initialized during first_call below
   COMMON /flux_arp/fsens,flat,ok_flux_surf
-!****************************************************************************************
 ! End of declarations
 !****************************************************************************************
@@ -546,11 +552,17 @@
     d_ts = 0.0    ; yfluxlat=0.0     ; flux_t = 0.0    ; flux_q = 0.0     
     flux_u = 0.0  ; flux_v = 0.0     ; d_t = 0.0       ; d_q = 0.0      
-    d_u = 0.0     ; d_v = 0.0        ; yqsol = 0.0    
+    d_t_diss= 0.0 ;d_u = 0.0     ; d_v = 0.0        ; yqsol = 0.0    
     ytherm = 0.0  ; ytke=0.
     
-    zcoefh(:,:) = 0.0
-    zcoefh(:,1) = 999999. ! zcoefh(:,k=1) should never be used
-    zcoefm(:,:) = 0.0
-    zcoefm(:,1) = 999999. !
+    tke(:,:,is_ave)=0.
+    IF (iflag_pbl<20.or.iflag_pbl>=30) THEN
+       zcoefh(:,:,:) = 0.0
+       zcoefh(:,1,:) = 999999. ! zcoefh(:,k=1) should never be used
+       zcoefm(:,:,:) = 0.0
+       zcoefm(:,1,:) = 999999. !
+    ELSE
+      zcoefm(:,:,is_ave)=0.
+      zcoefh(:,:,is_ave)=0.
+    ENDIF
     ytsoil = 999999. 
 
@@ -713,5 +725,5 @@
           ENDDO
        ENDDO
-       
+
        DO k = 1, nsoilmx
           DO j = 1, knon
@@ -747,4 +759,15 @@
             ypaprs, ypplay, yu, yv, yq, yt, yts, yrugos, yqsurf, ycdragm, &
             ycoefm, ycoefh, ytke)
+
+       IF (iflag_pbl>=20.AND.iflag_pbl<30) THEN
+! In this case, coef_diff_turb is called for the Cd only
+       DO k = 2, klev
+          DO j = 1, knon
+             i = ni(j)
+             ycoefh(j,k)   = zcoefh(i,k,nsrf)
+             ycoefm(j,k)   = zcoefm(i,k,nsrf)
+          ENDDO
+       ENDDO
+       ENDIF
        
 !****************************************************************************************
@@ -924,4 +947,12 @@
 
 
+     y_d_t_diss(:,:)=0.
+     IF (iflag_pbl>=20 .and. iflag_pbl<30) THEN
+        CALL yamada_c(knon,dtime,ypaprs,ypplay &
+    &   ,yu,yv,yt,y_d_u,y_d_v,y_d_t,ycdragm,ytke,ycoefm,ycoefh,ycoefq,y_d_t_diss,yustar &
+    &   ,iflag_pbl,nsrf)
+     ENDIF
+!     print*,'yamada_c OK'
+
        DO j = 1, knon
           y_dflux_t(j) = y_dflux_t(j) * ypct(j)
@@ -937,8 +968,8 @@
 !****************************************************************************************
 
-       tke(:,:,nsrf) = 0.
        DO k = 1, klev
           DO j = 1, knon
              i = ni(j)
+             y_d_t_diss(j,k)  = y_d_t_diss(j,k) * ypct(j)
              y_d_t(j,k)  = y_d_t(j,k) * ypct(j)
              y_d_q(j,k)  = y_d_q(j,k) * ypct(j)
@@ -951,8 +982,9 @@
              flux_v(i,k,nsrf) = y_flux_v(j,k)
 
-             tke(i,k,nsrf)    = ytke(j,k)
 
           ENDDO
        ENDDO
+
+!      print*,'Dans pbl OK1'
 
        evap(:,nsrf) = - flux_q(:,1,nsrf)
@@ -980,11 +1012,19 @@
        END DO
 
+!      print*,'Dans pbl OK2'
+
        DO k = 2, klev
           DO j = 1, knon
              i = ni(j)
-             zcoefh(i,k) = zcoefh(i,k) + ycoefh(j,k)*ypct(j)
-             zcoefm(i,k) = zcoefm(i,k) + ycoefm(j,k)*ypct(j)
+             tke(i,k,nsrf)    = ytke(j,k)
+             zcoefh(i,k,nsrf) = ycoefh(j,k)
+             zcoefm(i,k,nsrf) = ycoefm(j,k)
+             tke(i,k,is_ave) = tke(i,k,is_ave) + ytke(j,k)*ypct(j)
+             zcoefh(i,k,is_ave) = zcoefh(i,k,is_ave) + ycoefh(j,k)*ypct(j)
+             zcoefm(i,k,is_ave) = zcoefm(i,k,is_ave) + ycoefm(j,k)*ypct(j)
           END DO
        END DO
+
+!      print*,'Dans pbl OK3'
 
        IF ( nsrf .EQ. is_ter ) THEN 
@@ -1007,4 +1047,5 @@
           DO j = 1, knon
              i = ni(j)
+             d_t_diss(i,k) = d_t_diss(i,k) + y_d_t_diss(j,k)
              d_t(i,k) = d_t(i,k) + y_d_t(j,k)
              d_q(i,k) = d_q(i,k) + y_d_q(j,k)
@@ -1013,4 +1054,6 @@
           END DO
        END DO
+
+!      print*,'Dans pbl OK4'
 
 !****************************************************************************************
@@ -1040,9 +1083,12 @@
 ! Calculations of diagnostic t,q at 2m and u, v at 10m
 
+!      print*,'Dans pbl OK41'
+!      print*,'tair1,yt(:,1),y_d_t(:,1)'
+!      print*, tair1,yt(:,1),y_d_t(:,1)
        DO j=1, knon
           i = ni(j)
           uzon(j) = yu(j,1) + y_d_u(j,1)
           vmer(j) = yv(j,1) + y_d_v(j,1)
-          tair1(j) = yt(j,1) + y_d_t(j,1)
+          tair1(j) = yt(j,1) + y_d_t(j,1) + y_d_t_diss(j,1)
           qair1(j) = yq(j,1) + y_d_q(j,1)
           zgeo1(j) = RD * tair1(j) / (0.5*(ypaprs(j,1)+ypplay(j,1))) &
@@ -1058,4 +1104,7 @@
        END DO
        
+!      print*,'Dans pbl OK42A'
+!      print*,'tair1,yt(:,1),y_d_t(:,1)'
+!      print*, tair1,yt(:,1),y_d_t(:,1)
 
 ! Calculate the temperature et relative humidity at 2m and the wind at 10m 
@@ -1064,4 +1113,5 @@
             tairsol, qairsol, rugo1, psfce, patm, &
             yt2m, yq2m, yt10m, yq10m, yu10m, yustar)
+!      print*,'Dans pbl OK42B'
 
        DO j=1, knon
@@ -1077,4 +1127,5 @@
        END DO
 
+!      print*,'Dans pbl OK43'
 !IM Calcule de l'humidite relative a 2m (rh2m) pour diagnostique
 !IM Ajoute dependance type surface
@@ -1093,4 +1144,5 @@
        END IF
 
+!   print*,'OK pbl 5'
        CALL HBTM(knon, ypaprs, ypplay, &
             yt2m,yt10m,yq2m,yq10m,yustar, &
@@ -1113,4 +1165,5 @@
        END DO
        
+!   print*,'OK pbl 6'
 #else 
 ! T2m not defined
@@ -1130,4 +1183,5 @@
 !****************************************************************************************
     
+!   print*,'OK pbl 7'
     zxfluxt(:,:) = 0.0 ; zxfluxq(:,:) = 0.0
     zxfluxu(:,:) = 0.0 ; zxfluxv(:,:) = 0.0
@@ -1143,4 +1197,5 @@
     END DO
 
+!   print*,'OK pbl 8'
     DO i = 1, klon
        zxsens(i)     = - zxfluxt(i,1) ! flux de chaleur sensible au sol
@@ -1161,4 +1216,5 @@
     s_trmb2(:) = 0.0 ; s_trmb3(:) = 0.0
     
+!   print*,'OK pbl 9'
     
     DO nsrf = 1, nbsrf
@@ -1192,4 +1248,5 @@
        END DO
     END DO
+!   print*,'OK pbl 10'
 
     IF (check) THEN
@@ -1264,5 +1321,6 @@
        evap_rst, rugos_rst, agesno_rst, ftsoil_rst)
 
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "dimsoil.h"
 
@@ -1314,5 +1372,6 @@
     ! Give default values where new fraction has appread
 
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
     INCLUDE "dimsoil.h"
     INCLUDE "clesphys.h"
